package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.VehicleAttributeDefinition;
import de.humance.eco.profile.model.VehicleAttributeDefinitionModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the VehicleAttributeDefinition service. Represents a row in the &quot;Profile_VehicleAttributeDefinition&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.VehicleAttributeDefinitionModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link VehicleAttributeDefinitionImpl}.
 * </p>
 *
 * @author Humance
 * @see VehicleAttributeDefinitionImpl
 * @see de.humance.eco.profile.model.VehicleAttributeDefinition
 * @see de.humance.eco.profile.model.VehicleAttributeDefinitionModel
 * @generated
 */
public class VehicleAttributeDefinitionModelImpl extends BaseModelImpl<VehicleAttributeDefinition>
    implements VehicleAttributeDefinitionModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a vehicle attribute definition model instance should use the {@link de.humance.eco.profile.model.VehicleAttributeDefinition} interface instead.
     */
    public static final String TABLE_NAME = "Profile_VehicleAttributeDefinition";
    public static final Object[][] TABLE_COLUMNS = {
            { "vehicleAttributeDefinitionId", Types.BIGINT },
            { "creatorId", Types.BIGINT },
            { "creatorName", Types.VARCHAR },
            { "createDate", Types.TIMESTAMP },
            { "modifierId", Types.BIGINT },
            { "modifierName", Types.VARCHAR },
            { "modifiedDate", Types.TIMESTAMP },
            { "vehicleTypeId", Types.BIGINT },
            { "type_", Types.VARCHAR },
            { "title", Types.VARCHAR },
            { "minRangeValue", Types.DOUBLE },
            { "maxRangeValue", Types.DOUBLE },
            { "unit", Types.VARCHAR },
            { "sequenceNumber", Types.BIGINT }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_VehicleAttributeDefinition (vehicleAttributeDefinitionId LONG not null primary key,creatorId LONG,creatorName VARCHAR(75) null,createDate DATE null,modifierId LONG,modifierName VARCHAR(75) null,modifiedDate DATE null,vehicleTypeId LONG,type_ VARCHAR(75) null,title VARCHAR(500) null,minRangeValue DOUBLE,maxRangeValue DOUBLE,unit VARCHAR(255) null,sequenceNumber LONG)";
    public static final String TABLE_SQL_DROP = "drop table Profile_VehicleAttributeDefinition";
    public static final String ORDER_BY_JPQL = " ORDER BY vehicleAttributeDefinition.vehicleTypeId ASC, vehicleAttributeDefinition.sequenceNumber ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_VehicleAttributeDefinition.vehicleTypeId ASC, Profile_VehicleAttributeDefinition.sequenceNumber ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.VehicleAttributeDefinition"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.VehicleAttributeDefinition"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.VehicleAttributeDefinition"),
            true);
    public static long TITLE_COLUMN_BITMASK = 1L;
    public static long VEHICLETYPEID_COLUMN_BITMASK = 2L;
    public static long SEQUENCENUMBER_COLUMN_BITMASK = 4L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.VehicleAttributeDefinition"));
    private static ClassLoader _classLoader = VehicleAttributeDefinition.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            VehicleAttributeDefinition.class
        };
    private long _vehicleAttributeDefinitionId;
    private long _creatorId;
    private String _creatorName;
    private Date _createDate;
    private long _modifierId;
    private String _modifierName;
    private Date _modifiedDate;
    private long _vehicleTypeId;
    private long _originalVehicleTypeId;
    private boolean _setOriginalVehicleTypeId;
    private String _type;
    private String _title;
    private String _originalTitle;
    private double _minRangeValue;
    private double _maxRangeValue;
    private String _unit;
    private long _sequenceNumber;
    private long _columnBitmask;
    private VehicleAttributeDefinition _escapedModel;

    public VehicleAttributeDefinitionModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _vehicleAttributeDefinitionId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setVehicleAttributeDefinitionId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _vehicleAttributeDefinitionId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return VehicleAttributeDefinition.class;
    }

    @Override
    public String getModelClassName() {
        return VehicleAttributeDefinition.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("vehicleAttributeDefinitionId",
            getVehicleAttributeDefinitionId());
        attributes.put("creatorId", getCreatorId());
        attributes.put("creatorName", getCreatorName());
        attributes.put("createDate", getCreateDate());
        attributes.put("modifierId", getModifierId());
        attributes.put("modifierName", getModifierName());
        attributes.put("modifiedDate", getModifiedDate());
        attributes.put("vehicleTypeId", getVehicleTypeId());
        attributes.put("type", getType());
        attributes.put("title", getTitle());
        attributes.put("minRangeValue", getMinRangeValue());
        attributes.put("maxRangeValue", getMaxRangeValue());
        attributes.put("unit", getUnit());
        attributes.put("sequenceNumber", getSequenceNumber());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long vehicleAttributeDefinitionId = (Long) attributes.get(
                "vehicleAttributeDefinitionId");

        if (vehicleAttributeDefinitionId != null) {
            setVehicleAttributeDefinitionId(vehicleAttributeDefinitionId);
        }

        Long creatorId = (Long) attributes.get("creatorId");

        if (creatorId != null) {
            setCreatorId(creatorId);
        }

        String creatorName = (String) attributes.get("creatorName");

        if (creatorName != null) {
            setCreatorName(creatorName);
        }

        Date createDate = (Date) attributes.get("createDate");

        if (createDate != null) {
            setCreateDate(createDate);
        }

        Long modifierId = (Long) attributes.get("modifierId");

        if (modifierId != null) {
            setModifierId(modifierId);
        }

        String modifierName = (String) attributes.get("modifierName");

        if (modifierName != null) {
            setModifierName(modifierName);
        }

        Date modifiedDate = (Date) attributes.get("modifiedDate");

        if (modifiedDate != null) {
            setModifiedDate(modifiedDate);
        }

        Long vehicleTypeId = (Long) attributes.get("vehicleTypeId");

        if (vehicleTypeId != null) {
            setVehicleTypeId(vehicleTypeId);
        }

        String type = (String) attributes.get("type");

        if (type != null) {
            setType(type);
        }

        String title = (String) attributes.get("title");

        if (title != null) {
            setTitle(title);
        }

        Double minRangeValue = (Double) attributes.get("minRangeValue");

        if (minRangeValue != null) {
            setMinRangeValue(minRangeValue);
        }

        Double maxRangeValue = (Double) attributes.get("maxRangeValue");

        if (maxRangeValue != null) {
            setMaxRangeValue(maxRangeValue);
        }

        String unit = (String) attributes.get("unit");

        if (unit != null) {
            setUnit(unit);
        }

        Long sequenceNumber = (Long) attributes.get("sequenceNumber");

        if (sequenceNumber != null) {
            setSequenceNumber(sequenceNumber);
        }
    }

    @Override
    public long getVehicleAttributeDefinitionId() {
        return _vehicleAttributeDefinitionId;
    }

    @Override
    public void setVehicleAttributeDefinitionId(
        long vehicleAttributeDefinitionId) {
        _vehicleAttributeDefinitionId = vehicleAttributeDefinitionId;
    }

    @Override
    public long getCreatorId() {
        return _creatorId;
    }

    @Override
    public void setCreatorId(long creatorId) {
        _creatorId = creatorId;
    }

    @Override
    public String getCreatorName() {
        if (_creatorName == null) {
            return StringPool.BLANK;
        } else {
            return _creatorName;
        }
    }

    @Override
    public void setCreatorName(String creatorName) {
        _creatorName = creatorName;
    }

    @Override
    public Date getCreateDate() {
        return _createDate;
    }

    @Override
    public void setCreateDate(Date createDate) {
        _createDate = createDate;
    }

    @Override
    public long getModifierId() {
        return _modifierId;
    }

    @Override
    public void setModifierId(long modifierId) {
        _modifierId = modifierId;
    }

    @Override
    public String getModifierName() {
        if (_modifierName == null) {
            return StringPool.BLANK;
        } else {
            return _modifierName;
        }
    }

    @Override
    public void setModifierName(String modifierName) {
        _modifierName = modifierName;
    }

    @Override
    public Date getModifiedDate() {
        return _modifiedDate;
    }

    @Override
    public void setModifiedDate(Date modifiedDate) {
        _modifiedDate = modifiedDate;
    }

    @Override
    public long getVehicleTypeId() {
        return _vehicleTypeId;
    }

    @Override
    public void setVehicleTypeId(long vehicleTypeId) {
        _columnBitmask = -1L;

        if (!_setOriginalVehicleTypeId) {
            _setOriginalVehicleTypeId = true;

            _originalVehicleTypeId = _vehicleTypeId;
        }

        _vehicleTypeId = vehicleTypeId;
    }

    public long getOriginalVehicleTypeId() {
        return _originalVehicleTypeId;
    }

    @Override
    public String getType() {
        if (_type == null) {
            return StringPool.BLANK;
        } else {
            return _type;
        }
    }

    @Override
    public void setType(String type) {
        _type = type;
    }

    @Override
    public String getTitle() {
        if (_title == null) {
            return StringPool.BLANK;
        } else {
            return _title;
        }
    }

    @Override
    public void setTitle(String title) {
        _columnBitmask |= TITLE_COLUMN_BITMASK;

        if (_originalTitle == null) {
            _originalTitle = _title;
        }

        _title = title;
    }

    public String getOriginalTitle() {
        return GetterUtil.getString(_originalTitle);
    }

    @Override
    public double getMinRangeValue() {
        return _minRangeValue;
    }

    @Override
    public void setMinRangeValue(double minRangeValue) {
        _minRangeValue = minRangeValue;
    }

    @Override
    public double getMaxRangeValue() {
        return _maxRangeValue;
    }

    @Override
    public void setMaxRangeValue(double maxRangeValue) {
        _maxRangeValue = maxRangeValue;
    }

    @Override
    public String getUnit() {
        if (_unit == null) {
            return StringPool.BLANK;
        } else {
            return _unit;
        }
    }

    @Override
    public void setUnit(String unit) {
        _unit = unit;
    }

    @Override
    public long getSequenceNumber() {
        return _sequenceNumber;
    }

    @Override
    public void setSequenceNumber(long sequenceNumber) {
        _columnBitmask = -1L;

        _sequenceNumber = sequenceNumber;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            VehicleAttributeDefinition.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public VehicleAttributeDefinition toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (VehicleAttributeDefinition) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        VehicleAttributeDefinitionImpl vehicleAttributeDefinitionImpl = new VehicleAttributeDefinitionImpl();

        vehicleAttributeDefinitionImpl.setVehicleAttributeDefinitionId(getVehicleAttributeDefinitionId());
        vehicleAttributeDefinitionImpl.setCreatorId(getCreatorId());
        vehicleAttributeDefinitionImpl.setCreatorName(getCreatorName());
        vehicleAttributeDefinitionImpl.setCreateDate(getCreateDate());
        vehicleAttributeDefinitionImpl.setModifierId(getModifierId());
        vehicleAttributeDefinitionImpl.setModifierName(getModifierName());
        vehicleAttributeDefinitionImpl.setModifiedDate(getModifiedDate());
        vehicleAttributeDefinitionImpl.setVehicleTypeId(getVehicleTypeId());
        vehicleAttributeDefinitionImpl.setType(getType());
        vehicleAttributeDefinitionImpl.setTitle(getTitle());
        vehicleAttributeDefinitionImpl.setMinRangeValue(getMinRangeValue());
        vehicleAttributeDefinitionImpl.setMaxRangeValue(getMaxRangeValue());
        vehicleAttributeDefinitionImpl.setUnit(getUnit());
        vehicleAttributeDefinitionImpl.setSequenceNumber(getSequenceNumber());

        vehicleAttributeDefinitionImpl.resetOriginalValues();

        return vehicleAttributeDefinitionImpl;
    }

    @Override
    public int compareTo(VehicleAttributeDefinition vehicleAttributeDefinition) {
        int value = 0;

        if (getVehicleTypeId() < vehicleAttributeDefinition.getVehicleTypeId()) {
            value = -1;
        } else if (getVehicleTypeId() > vehicleAttributeDefinition.getVehicleTypeId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        if (getSequenceNumber() < vehicleAttributeDefinition.getSequenceNumber()) {
            value = -1;
        } else if (getSequenceNumber() > vehicleAttributeDefinition.getSequenceNumber()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof VehicleAttributeDefinition)) {
            return false;
        }

        VehicleAttributeDefinition vehicleAttributeDefinition = (VehicleAttributeDefinition) obj;

        long primaryKey = vehicleAttributeDefinition.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        VehicleAttributeDefinitionModelImpl vehicleAttributeDefinitionModelImpl = this;

        vehicleAttributeDefinitionModelImpl._originalVehicleTypeId = vehicleAttributeDefinitionModelImpl._vehicleTypeId;

        vehicleAttributeDefinitionModelImpl._setOriginalVehicleTypeId = false;

        vehicleAttributeDefinitionModelImpl._originalTitle = vehicleAttributeDefinitionModelImpl._title;

        vehicleAttributeDefinitionModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<VehicleAttributeDefinition> toCacheModel() {
        VehicleAttributeDefinitionCacheModel vehicleAttributeDefinitionCacheModel =
            new VehicleAttributeDefinitionCacheModel();

        vehicleAttributeDefinitionCacheModel.vehicleAttributeDefinitionId = getVehicleAttributeDefinitionId();

        vehicleAttributeDefinitionCacheModel.creatorId = getCreatorId();

        vehicleAttributeDefinitionCacheModel.creatorName = getCreatorName();

        String creatorName = vehicleAttributeDefinitionCacheModel.creatorName;

        if ((creatorName != null) && (creatorName.length() == 0)) {
            vehicleAttributeDefinitionCacheModel.creatorName = null;
        }

        Date createDate = getCreateDate();

        if (createDate != null) {
            vehicleAttributeDefinitionCacheModel.createDate = createDate.getTime();
        } else {
            vehicleAttributeDefinitionCacheModel.createDate = Long.MIN_VALUE;
        }

        vehicleAttributeDefinitionCacheModel.modifierId = getModifierId();

        vehicleAttributeDefinitionCacheModel.modifierName = getModifierName();

        String modifierName = vehicleAttributeDefinitionCacheModel.modifierName;

        if ((modifierName != null) && (modifierName.length() == 0)) {
            vehicleAttributeDefinitionCacheModel.modifierName = null;
        }

        Date modifiedDate = getModifiedDate();

        if (modifiedDate != null) {
            vehicleAttributeDefinitionCacheModel.modifiedDate = modifiedDate.getTime();
        } else {
            vehicleAttributeDefinitionCacheModel.modifiedDate = Long.MIN_VALUE;
        }

        vehicleAttributeDefinitionCacheModel.vehicleTypeId = getVehicleTypeId();

        vehicleAttributeDefinitionCacheModel.type = getType();

        String type = vehicleAttributeDefinitionCacheModel.type;

        if ((type != null) && (type.length() == 0)) {
            vehicleAttributeDefinitionCacheModel.type = null;
        }

        vehicleAttributeDefinitionCacheModel.title = getTitle();

        String title = vehicleAttributeDefinitionCacheModel.title;

        if ((title != null) && (title.length() == 0)) {
            vehicleAttributeDefinitionCacheModel.title = null;
        }

        vehicleAttributeDefinitionCacheModel.minRangeValue = getMinRangeValue();

        vehicleAttributeDefinitionCacheModel.maxRangeValue = getMaxRangeValue();

        vehicleAttributeDefinitionCacheModel.unit = getUnit();

        String unit = vehicleAttributeDefinitionCacheModel.unit;

        if ((unit != null) && (unit.length() == 0)) {
            vehicleAttributeDefinitionCacheModel.unit = null;
        }

        vehicleAttributeDefinitionCacheModel.sequenceNumber = getSequenceNumber();

        return vehicleAttributeDefinitionCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(29);

        sb.append("{vehicleAttributeDefinitionId=");
        sb.append(getVehicleAttributeDefinitionId());
        sb.append(", creatorId=");
        sb.append(getCreatorId());
        sb.append(", creatorName=");
        sb.append(getCreatorName());
        sb.append(", createDate=");
        sb.append(getCreateDate());
        sb.append(", modifierId=");
        sb.append(getModifierId());
        sb.append(", modifierName=");
        sb.append(getModifierName());
        sb.append(", modifiedDate=");
        sb.append(getModifiedDate());
        sb.append(", vehicleTypeId=");
        sb.append(getVehicleTypeId());
        sb.append(", type=");
        sb.append(getType());
        sb.append(", title=");
        sb.append(getTitle());
        sb.append(", minRangeValue=");
        sb.append(getMinRangeValue());
        sb.append(", maxRangeValue=");
        sb.append(getMaxRangeValue());
        sb.append(", unit=");
        sb.append(getUnit());
        sb.append(", sequenceNumber=");
        sb.append(getSequenceNumber());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(46);

        sb.append("<model><model-name>");
        sb.append("de.humance.eco.profile.model.VehicleAttributeDefinition");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>vehicleAttributeDefinitionId</column-name><column-value><![CDATA[");
        sb.append(getVehicleAttributeDefinitionId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorId</column-name><column-value><![CDATA[");
        sb.append(getCreatorId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorName</column-name><column-value><![CDATA[");
        sb.append(getCreatorName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>createDate</column-name><column-value><![CDATA[");
        sb.append(getCreateDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifierId</column-name><column-value><![CDATA[");
        sb.append(getModifierId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifierName</column-name><column-value><![CDATA[");
        sb.append(getModifierName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
        sb.append(getModifiedDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>vehicleTypeId</column-name><column-value><![CDATA[");
        sb.append(getVehicleTypeId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>type</column-name><column-value><![CDATA[");
        sb.append(getType());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>title</column-name><column-value><![CDATA[");
        sb.append(getTitle());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>minRangeValue</column-name><column-value><![CDATA[");
        sb.append(getMinRangeValue());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>maxRangeValue</column-name><column-value><![CDATA[");
        sb.append(getMaxRangeValue());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>unit</column-name><column-value><![CDATA[");
        sb.append(getUnit());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>sequenceNumber</column-name><column-value><![CDATA[");
        sb.append(getSequenceNumber());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
